import 'dart:math';
import 'package:base62x/base62x.dart';
import 'package:test/test.dart';

void main() {
  test('Base62x encode', () {
    expect(Base62x.encode('hello,world!'), 'helloxdworldxSx');
  });

  test('Base62x decode', () {
    expect(Base62x.decode('helloxdworldxSx'), 'hello,world!');
  });

  test('Base62x codec', () {
    const orgStr =
        '{},./?\'"【】「」。，？|abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ{"page": "/xx/yy/zz?id=123"},./?\'"【】「」。，？|地是有的和主经不为这工要在我一上人中国同民了发以产啊阿爱安暗芭吧百瓣半办帮包保报北本比笔必避陛边{"page": "/xx/yy/zz?id=123"},./?\'"【】「」。，？|变表宾冰并伯泊步部才财采菜餐参惭灿册查昌长偿吵炒车晨忱陈称城成呈承持池弛耻赤炽充抽出处春磁此从粗村达答打大呆代胆淡当档刀导到得灯邓迪第帝电佃甸盯钉锭定订东度断队对多夺朵儿二罚法凡反贩芳方防妨纺放肥分坟粉丰风烽冯凤夫服负妇肝敢肛纲高革格蛤个各给耿攻功公宫贡共垢构估孤姑骨顾怪关官观管光归轨辊果过害汉好恨虹红后呼胡虎互画划化怀换蝗煌晃灰毁会婚伙或圾基机肌吉极及级几季寂计记际继纪家加尖间艰检渐江匠降胶交角较叫节杰结介届紧进近睛景久九旧舅就居具决军开楷苛科可克客肯空扣枯宽昆困扩拉来乐累肋类楞离理李历立力联脸良量辽料列林灵另刘六龙娄搂卢卤录吕屡率绿罗妈马嘛慢么玫煤没们眯迷米秘绵面秒明名末牟姆睦哪奶南男难内能尼你年宁怕炮朋批皮平普妻七岂钱前欠强悄峭切且亲沁轻顷庆秋区曲取权全劝然让认扔仍如入闰弱洒三扫色砂纱闪商少社审生失时实史式示世事氏收手守曙术甩霜双水睡顺说思肆寺四诉虽{"page": "/xx/yy/zz?id=123"},./?\'"【】「」。，？|孙所他它台太膛提啼天条铁厅听烃瞳屯驼妥拓外晚宛汪委胃卫闻无五物务析吸习戏细瞎下仙嫌显现限线相向宵小肖协械懈心信兴行凶胸休秀须旭轩喧眩学雪旬寻巡训押呀牙烟炎眼燕央杨洋阳样遥药也业叶衣姨矣亿忆义因阴引隐蝇哟用由邮友右于愉与玉遇原员约匀允晕杂灾载早澡灶则增曾赠粘斩崭占站张涨找折贞针争之芝脂支知职直旨止只炙肿妯珠烛驻注妆籽字综最昨左作埃挨哎唉哀癌蔼艾碍隘鞍氨按胺案肮昂盎袄奥懊澳扒叭笆八疤巴拔靶把耙坝霸罢爸白柏摆佰败斑班搬扳般颁板扮伴绊邦梆榜膀绑棒磅蚌镑傍谤苞胞褒薄雹宝抱暴鲍爆杯碑背钡倍备惫焙奔苯笨崩绷甭泵迸鼻鄙彼碧蓖蔽毕币庇闭敝辟鞭贬便卞辨辩辫遍标膘别彬斌滨摈兵柄丙秉饼炳病玻菠拨钵波博勃铂箔帛舶脖渤驳捕卜哺补埠布簿怖裁材睬彩蔡蚕残惨苍舱仓沧操糙曹草策侧测层插叉茶碴差拆柴豺掺谗缠铲阐尝肠厂唱超抄钞朝嘲潮巢扯撤郴臣辰尘沉衬撑乘诚逞骋秤吃迟驰齿侈尺翅斥冲崇宠畴仇绸瞅丑初雏滁除楚础储揣椽喘串疮窗状床闯创吹炊垂淳纯绰疵雌刺赐次匆丛凑醋簇促窜摧崔催脆瘁粹存磋撮搓措挫错瘩歹傣带殆贷逮怠耽担丹旦氮但惮弹蛋挡党荡倒祷稻德瞪低滴敌笛涤嫡抵底蒂弟缔掂碘点典靛店惦殿碉叼凋刁掉吊调跌碟蝶迭谍丁叮顶鼎丢冬董懂动栋恫冻斗陡豆独读堵睹杜镀肚渡端短锻段缎堆墩吨敦囤盾掇哆垛跺剁惰蛾峨俄娥厄扼饿恩而耳尔贰筏伐乏阀珐帆番矾烦返范犯饭泛坊肪房仿访菲非啡飞诽吠肺沸费芬酚吩氛纷焚汾奋份愤枫蜂峰锋疯逢讽奉佛否肤扶辐幅氟符伏俘{"page": "/xx/yy/zz?id=123"},./?\'"【】「」。，？|浮涪福弗甫抚俯釜斧脯腑府赴副覆赋复傅付父腹富讣附缚咐噶嘎改概钙盖溉甘杆柑竿秆赣冈刚钢缸岗杠膏羔搞镐稿哥搁胳疙葛阁隔铬根跟耕更庚埂龚供弓巩汞拱钩勾沟狗购辜菇咕箍沽古蛊谷股故固瓜寡乖拐棺馆惯灌贯瑰规圭硅龟鬼诡癸桂柜滚棍锅郭哈骸海邯涵寒函罕翰扞旱悍焊汗夯杭航壕嚎毫郝号呵喝菏禾何合阂河涸赫鹤贺嘿黑痕很狠哼亨横恒轰哄烘洪宏弘喉侯猴吼厚候乎忽瑚壶蝴狐糊湖弧护沪户花哗华猾滑话槐徊淮坏欢环还缓唤痪豢焕涣宦幻慌黄磺皇凰恍谎挥恢蛔回悔慧卉惠晦贿秽烩汇诲绘魂浑混活火获货击畸积箕饥迹激讥鸡姬绩缉辑集急疾汲即嫉挤脊己技冀祭悸济寄既忌妓枷夹贾钾假稼价架驾嫁歼坚笺兼奸缄茧柬碱简减荐槛践贱见箭件健剑僵姜将浆疆蒋桨奖讲蕉椒礁焦郊浇嚼铰狡缴绞轿揭接皆阶截桔捷睫洁解姐戒藉芥界借疥巾斤襟锦仅谨靳禁烬浸尽劲荆兢茎晶鲸京精粳井颈静境敬镜径痉靖竟净炯揪究纠玖灸厩臼咎疚鞠拘疽驹菊局咀矩举沮聚拒据巨距锯俱句惧炬剧捐鹃娟倦绢攫爵绝均菌峻俊竣骏喀咖卡咯凯慨刊堪坎砍看康慷扛亢炕考拷烤坷柯棵磕颗壳渴刻课啃垦坑吭孔控抠窟苦库裤夸跨胯块筷快款匡筐狂矿眶旷况亏盔岿葵傀馈愧溃捆括廓阔垃喇蜡腊辣啦莱蓝婪栏拦兰澜谰揽缆滥琅榔狼廊朗浪捞劳牢老佬姥烙涝勒雷镭磊儡擂泪棱梨犁黎篱里莉荔吏栗丽厉砾利傈例俐痢粒沥隶璃哩俩莲连涟帘链恋练粮梁辆亮谅撩聊僚疗寥撂镣廖劣猎琳磷霖临鳞淋凛吝玲凌陵令琉榴硫流柳聋咙笼窿隆垄拢陇楼篓陋炉掳鲁碌路赂鹿禄陆戮驴铝侣履缕虑氯滤峦挛孪卵乱略抡轮伦仑沦纶论萝螺逻锣箩骡落洛骆络麻玛码蚂骂吗埋麦迈蛮蔓曼谩芒茫盲莽锚毛矛铆茂冒帽贸枚梅眉媒镁每昧妹媚门闷萌蒙檬盟锰梦孟醚弥觅泌密幂棉眠免娩苗描瞄藐庙妙灭抿皿悯闽螟鸣铭蘑模抹莫沫漠寞陌谋某拇亩母牧穆呐钠那娜纳氖乃奈囊脑恼闹淖呢馁嫩妮霓倪泥拟腻逆溺碾娘尿聂镊镍柠狞凝拧泞牛扭钮纽脓浓农弄奴努怒女暖虐挪糯诺哦欧殴偶沤啪趴帕琶拍排湃派攀盘盼畔乓庞旁胖抛咆袍跑泡呸胚培赔陪配佩喷盆砰烹棚硼膨鹏{"page": "/xx/yy/zz?id=123"},./?\'"【】「」。，？|捧碰砒霹披琵毗啤脾疲匹痞僻屁片漂拼频贫品聘乒坪苹瓶评屏坡颇破迫粕剖扑铺仆莆葡菩朴谱曝瀑栖戚漆柒沏其棋歧畦崎脐齐旗祈祁骑起乞企启契砌器气迄弃汽泣掐洽牵钎铅千迁谦乾钳潜浅堑嵌枪呛腔蔷抢橇锹桥瞧乔侨俏钦侵秦琴芹禽青氢倾清晴情请穷丘邱球求囚泅屈驱娶趣去圈颧泉痊拳券缺炔却确群冉染壤攘嚷饶扰绕壬仁任刃妊纫戎茸蓉荣融熔容绒冗肉茹儒孺乳汝软阮蕊瑞锐若撒萨鳃叁伞散嗓丧嫂瑟涩森僧杀刹沙煞晒珊苫杉山衫陕擅赡汕缮墒伤晌梢捎稍烧芍勺韶哨邵绍奢赊蛇舌舍赦慑涉设砷申呻伸身深娠绅神沈婶肾慎渗声升省胜圣师施湿诗虱十什食蚀识矢屎驶始拭逝噬适仕侍释恃室视试首寿授售受瘦兽蔬枢梳殊抒输叔疏书赎熟暑蜀黍鼠渚述树束竖庶数恕刷摔帅栓拴爽税吮瞬硕烁撕嘶私司丝死嗣伺似松耸怂颂送宋讼搜苏素粟僳溯肃酸蒜算隋随绥髓碎岁遂隧祟损笋蓑梭唆缩琐索锁塌她挞胎苔抬态汰摊滩坛檀痰潭谭谈坦碳叹炭汤塘搪唐糖倘淌趟掏涛滔绦萄桃逃淘陶讨套特藤腾疼梯踢锑体替惕屉添填田恬腆挑迢眺跳帖汀停亭艇通彤桶捅统痛投头透凸秃突图途涂屠吐湍团腿蜕退吞拖托脱陀驮椭唾哇蛙娃瓦袜歪弯湾玩顽丸烷完碗皖婉万腕王亡枉网往旺威巍微危韦桅惟潍维苇萎伟伪尾未蔚味畏魏位渭谓慰瘟温蚊纹吻稳问嗡翁瓮挝蜗涡握巫钨乌污诬屋梧吾吴毋武午舞伍侮戊雾晤勿误昔硒矽晰嘻锡牺稀息希悉膝烯溪汐犀檄袭席喜洗系隙匣暇峡侠厦夏吓掀锨先鲜纤咸贤衔闲弦险县腺羡宪陷厢镶香箱襄乡祥详想响享项巷橡像象萧硝霄削哮销消淆晓孝校啸笑效楔些歇蝎挟胁写卸谢薪芯锌欣新忻衅星腥惺形邢醒幸杏性姓兄匈雄修羞袖戌需虚徐许蓄叙序畜恤絮绪续宣旋玄癣绚穴血勋熏询驯殉汛讯逊迅压鸭丫芽蚜衙涯哑亚讶焉咽淹盐严研岩延言沿奄衍演艳厌砚雁唁焰宴谚验殃鸯扬疡羊氧痒腰妖瑶摇窑谣姚咬舀椰噎耶爷野冶页掖曳夜液壹医揖铱依伊夷移仪胰沂宜彝椅蚁倚乙艺抑易邑役臆疫亦裔意毅益溢诣议谊译异翼翌绎茵荫殷音姻银淫寅饮尹印英婴应缨萤营荧迎盈颖硬映拥佣臃痈雍踊咏涌永恿勇幽优忧尤铀油酉佑釉诱又幼迂盂虞舆余鱼隅予屿禹宇语羽芋郁御育浴寓裕预豫驭鸳渊冤元袁援辕园源缘远苑怨院越钥岳粤月悦阅云郧陨运蕴酝孕匝栽哉宰再咱暂赃脏葬凿藻蚤皂燥责择泽憎扎喳札轧铡闸眨栅榨乍炸诈摘斋宅瞻詹沾盏辗展{"page": "/xx/yy/zz?id=123"},./?\'"【】「」。，？|栈战湛绽樟章彰漳杖丈帐胀账钊招啁诏棹召罩沼蜇辄辙者浙柘浈桢真诊鸩圳峥震征拯郑政正汁吱枝织胝症执咫夂轵址至陟轾酯秩稚豸彘治终盅舯忠众重周舟洲碡肘纣荮咒绉株茱铢诸侏竺属丶着筑蛀瞩杼炷贮拽专赚庄桩幢壮椎隹锥卓准捉灼诼酌斫孜兹赀嵫仔梓紫訾踪纵宗鬃总走奏菹足诅蕞嘴醉尊撙怍座做佐皑矮俺岸凹敖厨熬翱傲捌跋拜稗版拌剥堡饱豹悲卑辈贝狈被蹦逼毙毖痹弊壁臂编扁彪鳖憋瘪濒播搏膊擦猜踩藏槽厕蹭茬搽察岔诧搀蝉馋颤猖场常敞畅倡掣彻澈趁橙程惩澄痴匙虫酬踌稠愁筹臭橱躇锄矗搐触川穿传船捶锤椿醇唇蠢戳茨辞慈瓷词聪葱囱蹿篡淬翠寸搭戴袋待单郸掸诞捣蹈岛悼道盗蹬登等凳堤狄翟递颠滇垫奠淀雕钓爹叠侗洞兜抖逗痘都督毒犊赌妒兑蹲顿钝遁躲舵堕鹅额讹恶遏鄂饵藩翻樊钒繁匪废忿粪封缝敷孵拂袱辅腐阜该干赶感港篙皋糕告歌戈鸽割羹梗恭躬苟够鼓雇刮剐挂褂冠罐广逛闺跪贵刽裹孩氦亥骇酣憨韩含喊撼憾豪耗浩荷核盒貉褐衡鸿葫唬桓患荒簧惶幌辉徽讳荤昏豁惑霍祸稽棘籍蓟伎剂嘉佳荚颊甲监煎肩硷拣捡俭剪鉴键舰饯溅涧建酱骄娇搅矫侥脚饺剿教酵窖秸街劫竭诫筋金今津晋惊警竞窘韭酒救狙踞眷卷撅抉掘倔觉诀钧君浚郡{"page": "/xx/yy/zz?id=123"},./?\'"【】「」。，？|揩勘糠抗靠咳恳恐口寇哭酷垮侩框窥奎魁坤赖篮阑览懒烂郎酪蕾垒冷厘狸漓鲤礼励镰廉怜敛炼凉粱两晾燎潦裂烈邻赁拎菱零龄铃伶羚岭领溜馏留瘤漏芦颅庐虏麓露潞旅律滦掠裸买卖脉瞒馒满漫氓忙猫茅卯貌酶霉美寐猛靡糜谜蜜冕勉缅渺蔑敏命谬摸摹膜磨摩魔墨默牡墓暮幕募慕木目拿耐挠匿蔫拈撵捻念酿鸟捏孽啮涅您疟懦鸥藕呕爬牌徘潘磐判叛耪刨裴沛抨澎彭蓬篷坯劈譬篇偏骗飘瓢票撇瞥萍凭泼婆魄蒲埔圃浦期欺凄奇讫恰扦签仟黔遣谴歉羌墙敲巧鞘撬翘窍茄怯窃勤擒寝卿擎氰琼酋趋蛆躯渠龋醛犬瘸鹊榷雀裙燃瓤惹热忍韧日溶揉柔蠕辱褥润腮塞赛桑搔骚莎傻啥筛删煽膳善扇赏尚裳摄射甚甥牲绳{"page": "/xx/yy/zz?id=123"},./?\'"【】「」。，？|盛剩狮尸石拾使士柿誓势嗜饰市舒淑孰薯署戍墅漱耍衰谁舜朔斯饲巳诵艘擞嗽酥俗速塑宿穗塔獭蹋踏泰酞坍贪瘫毯袒探堂棠躺烫誊剔题蹄嚏涕剃甜舔贴廷庭挺桐酮铜童筒偷徒土兔推颓褪臀鸵挖洼豌挽惋望忘妄违围唯纬喂尉文紊窝斡卧沃呜芜捂坞悟熙西夕惜熄媳铣虾霞辖狭舷涎献馅湘翔嚣鞋携邪斜谐蟹泄泻屑辛猩刑型汹熊朽嗅锈绣墟嘘酗婿悬选靴薛循鸦崖雅阉蜒颜阎掩堰彦秧佯仰养漾邀尧耀腋颐遗疑已屹逸肄吟樱鹰莹赢影庸蛹泳悠犹游淤榆愚俞逾渝渔娱雨域吁喻峪愈欲狱誉垣圆猿愿曰跃耘韵砸攒赞遭糟枣躁噪造贼怎渣咋窄债寨毡蘸掌仗幛照遮磔褶祯斟箴鹧畛臻镇赈筝钲挣徵整帧诤埴侄植蜘帙郅桎骘掷智{"page": "/xx/yy/zz?id=123"},./?\'"【】「」。，？|帜痔踬螽踵仲州诌酎籀橥麈煮疰住翥抓爪颛啭撰馔丬骓缒坠窀谆倬啄涿咨资镯鲻恣腙粽鲰揍卒俎镞阻纂缵攥洱挎瘴障昭赵兆肇哲蛰锗蔗珍甄砧侦枕疹振阵{"page": "/xx/yy/zz?id=123"},./?\'"【】「」。，？|蒸睁狰怔证肢殖值指趾纸志挚致置峙制质滞窒钟衷种粥轴帚皱宙昼骤蛛朱猪诛逐竹拄嘱柱助铸祝砖转篆装撞追赘缀拙桌琢茁浊姿滋淄滓子自渍棕邹租族祖组钻罪遵柞{"page": "/xx/yy/zz?id=123"},./?\'"【】「」。，？|坐拗骠簸禅枞枸桧偈矜蠡踉镏偻捋缪缥蹊荨镪趄葚螫沓圩熨芪冥巅潢{"page": "/xx/yy/zz?id=123"},./?\'"【】「」。，？|';
    const orgStrLength = orgStr.length;
    const testTimes = 3000;
    final random = Random(orgStrLength);
    for (var i = 0; i < testTimes; i++) {
      final m = random.nextDouble();
      final n = random.nextDouble();
      final x = (m * orgStrLength).floor();
      final y = (n * orgStrLength).floor();
      final testStr = orgStr.substring(min(x, y), max(x, y));
      final encodeStr = Base62x.encode(testStr);
      final decodeStr = Base62x.decode(encodeStr);
      expect(decodeStr, testStr);
    }
  });
}